/*
**	space.c - space demo
**
**	(c)1987 George Breen
**	Shelbourne Software Systems, Inc.
**	7221 Rising Sun Ave, #191
**	Philadelphia, PA 19111
*/
short savepal[16];
short npalet[16] = {
	0,0x111,0x111,0x222,0x222,0x333,0x333,
	0x444,0x444,0x555,0x555,0x666,0x666,0x777,0x777,0x555};
#include <osbind.h>
#include <stdio.h>
#define MAXBACK 200
#define MAXSTAR 200
struct SMASK {
	unsigned short pl1;
	unsigned short pl2;
	unsigned short pl3;
	unsigned short pl4;
};

struct SMASK tmplate = {1,1,1,1};
unsigned short orin[16];
short *orgsc, *p1, *p2;
int oldres;
short colback[4] = {
	1,1,1,0};
short sc1[32768/2],sc2[32768/2];
struct STAR {
	short *lp1, lp1m;
	short *lp2, lp2m;
	long x, y, z;
	long dx, dy, dz;	
	long color,dc,lc;
	long rdx, rdy;
} allstars[MAXSTAR];

main()
{
	initmask();
	initscrn();
	dostars();
	exitscrn();
}
initmask()
{
	int i;
	for(i=0; i< 16; i++) 
		orin[i] = 1 << (15 - i);
}
initscrn()
{
	int i,j,in;
	short *sp;
	oldres = Getrez();
	for(i=0; i<16; i++)  savepal[i] = Setcolor(i,-1);
	Setpallete(npalet);
	Setscreen(-1L,-1L, 0);
	p1 = &sc1[0];
	p1 += 128;
	(long)p1 &=(0xffffff00L);
	p2 = &sc2[0];
	p2 += 128;
	(long)p2 &= (0xffffff00L);
	for(i=0;i<32000/2;i++) *(p1+i) = *(p2+i) = 0; /* clr scrn */
	orgsc = Physbase();
/*
**	Background noise
*/
	for(j=0; j< 3; j++) 
		for(i=0; i<MAXSTAR; i++)  
			newstar(i);
	for(i=0; i<MAXSTAR; i++)  
		newstar(i);
	stereo_switch(1,p1,p2);
}
newstar(i)
int i;
{
	int j;
	allstars[i].dx = (long)(512 - (Random() % 1024));
	allstars[i].dy = (long)(512 - (Random() % 1024));
	allstars[i].dz =  -(long)((40 * (512 - Random() % 1024))/ 160);
ag:
	j = Random() % 40;
	allstars[i].x = (160 * 256) + allstars[i].dx * (long)j;
	allstars[i].y = (100 * 256) + allstars[i].dy * (long)j;
	if((allstars[i].x < 0) || (allstars[i].y < 0) ||
	   (allstars[i].x > 300 * 256L) || (allstars[i].y > 200*256L))
		goto ag;
	allstars[i].z = (10L + (Random % 7)) * 256L;
	allstars[i].color = (1 + (Random() % 3)) * 256;
	allstars[i].dc = Random() % 128;
	allstars[i].rdx = (j * allstars[i].dx)/40;
	allstars[i].rdy = (j * allstars[i].dy)/40;
	plotstar(&allstars[i]);
}
dostars() {
	int i,j,k;
	register struct STAR *sp;
	short lastc;
	short m1, m2, *mp1, *mp2;
	while(!Bconstat(2)) {
		for(i=0,sp=allstars; i < MAXSTAR; i++,++sp) {
			mp1 = sp->lp1;
			mp2 = sp->lp2;
			m1 = sp->lp1m;
			m2 = sp->lp2m;
			if((lastc = sp->lc) & 1) {
				*mp1 ^= m1;
				*mp2 ^= m2;
			}
			if(lastc & 2) {
				*(mp1 + 1) ^= m1;
				*(mp2 + 1) ^= m2;
			}
			if(lastc & 4) {
				*(mp1 + 2) ^= m1;
				*(mp2 + 2) ^= m2;
			}
			if(lastc & 8) {
				*(mp1 + 3) ^= m1;
				*(mp2 + 3) ^= m2;
			}
			sp->x += sp->dx;
			sp->y += sp->dy;
			sp->z += sp->dz;
			sp->dx += sp->rdx;
			sp->dy += sp->rdy;
			sp->color += sp->dc;
			if(sp->color > (15L * 256L)) {
				sp->dc = 0;
				sp->color = 15L * 256L;
			}
			if((sp->x >300 * 256L)||
			   (sp->x < 0) ||
			   (sp->y > 200 * 256L) ||
			   (sp->y < 0)) newstar(i);
			else 
				plotstar(sp);
		}
	}
}
exitscreen()
{
	stereo_switch(0, p1, p2);
	Setpallete(savepal);
	Setscreen(orgsc, orgsc, oldres);
}	
/*
**	Plot a star at x,y on plane 1, x+z,y on plane 2 in color c
*/
#define MIN(a,b) ((a < b) ? (a): (b))

plotstar(sp)
register struct STAR *sp;
{
	unsigned short im, im2;
	int x,y,z,j,a,b;
	long col;
	x = (int)(sp->x >> 8);
	y = (int)(sp->y >> 8);
	z = (int)(sp->z >> 8);
	b = (x+z) & 0xf;
	a = x & 0xf;
	sp->lp1m = im = orin[a];
	sp->lp2m = im2 = orin[b];
	sp->lp1 =  p1 + (y * 80) + (x/16) * 4;
	sp->lp2 = p2 + (y * 80) + ((x + z)/16) * 4;
	sp->lc = col =sp->color/256;
	if(col & 1) {
		*(sp->lp1) ^= im;
		*(sp->lp2) ^= im2;
	}
	if(col & 2) {
		*(sp->lp1 + 1) ^= im;
		*(sp->lp2 + 1) ^= im2;
	}
	if(col & 4) {
		*(sp->lp1 + 2) ^= im;
		*(sp->lp2 + 2) ^= im2;
	}
	if(col & 8) {
		*(sp->lp1 + 3) ^= im;
		*(sp->lp2 + 3) ^= im2;
	}
}
